Index: branches/2012/dev_r3438_LOCEAN15_PISLOB/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml
===================================================================
--- branches/2012/dev_r3438_LOCEAN15_PISLOB/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 3447)
+++ branches/2012/dev_r3438_LOCEAN15_PISLOB/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 3463)
@@ -19,5 +19,5 @@
      <group id="ptrc_T" axis_ref="deptht" grid_ref="grid_T">
        <field id="DIC"      description="Dissolved inorganic Concentration"        unit="mmol/m3" />
-       <field id="Alkalini" description="Total Alkalinity Concentration"           unit="mmol/m3"    />
+       <field id="Alkalini" description="Total Alkalinity Concentration"           unit="mmol/m3" />
        <field id="O2"       description="Oxygen Concentration"                     unit="mmol/m3" />
        <field id="CaCO3"    description="Calcite Concentration"                    unit="mmol/m3" />
@@ -38,6 +38,6 @@
        <field id="GSi"      description="Sinking biogenic Silicate Concentration"  unit="mmol/m3" />
        <field id="NFe"      description="Nano iron Concentration"                  unit="mmol/m3" />
-       <field id="NCHL"     description="Nano chlorophyl Concentration"            unit="mg/m3" />
-       <field id="DCHL"     description="Diatoms chlorophyl Concentration"         unit="mg/m3" />
+       <field id="NCHL"     description="Nano chlorophyl Concentration"            unit="mg/m3"   />
+       <field id="DCHL"     description="Diatoms chlorophyl Concentration"         unit="mg/m3"   />
        <field id="NO3"      description="Nitrates Concentration"                   unit="mmol/m3" />
        <field id="NH4"      description="Ammonium Concentration"                   unit="mmol/m3" />
@@ -47,57 +47,57 @@
 
      <group id="diad_T" axis_ref="none" grid_ref="grid_T">
-       <field id="PH"          description="PH"                                       unit="-"          axis_ref="deptht" />
-       <field id="CO3"         description="Bicarbonates"                             unit="mol/m3"     axis_ref="deptht" />
-       <field id="CO3sat"      description="CO3 saturation"                           unit="mol/m3"     axis_ref="deptht" />
-       <field id="PAR"         description="Photosynthetically Available Radiation"   unit="W/m2"       axis_ref="deptht" />
-       <field id="PPPHY"       description="Primary production of nanophyto"          unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="PPPHY2"      description="Primary production of diatoms"            unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="PPNEWN"      description="New Primary production of nanophyto"      unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="PPNEWD"      description="New Primary production of diatoms"        unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="PBSi"        description="Primary production of Si diatoms"         unit="molSi/m3/s"   axis_ref="deptht" />
-       <field id="PFeN"        description="Primary production of nano iron"          unit="molFe/m3/s"   axis_ref="deptht" />
-       <field id="PFeD"        description="Primary production of diatoms iron"       unit="molFe/m3/s"   axis_ref="deptht" />
-       <field id="xfracal"     description="Calcifying fraction"                      unit="-"          axis_ref="deptht" />
-       <field id="PCAL"        description="Calcite production"                       unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="DCAL"        description="Calcite dissolution"                      unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="GRAZ1"       description="Grazing by microzooplankton"              unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="GRAZ2"       description="Grazing by mesozooplankton"              unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="REMIN"       description="Oxic remineralization of OM"             unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="DENIT"       description="Anoxic remineralization of OM"           unit="molC/m3/s"   axis_ref="deptht" />
-       <field id="Nfix"        description="Nitrogen fixation"                         unit="molN/m3/s"   axis_ref="deptht" />
-       <field id="Mumax"       description="Maximum growth rate"                      unit="s-1"        axis_ref="deptht" />
-       <field id="MuN"         description="Realized growth rate for nanophyto"       unit="s-1"        axis_ref="deptht" />
-       <field id="MuD"         description="Realized growth rate for diatomes"        unit="s-1"        axis_ref="deptht" />
-       <field id="LNnut"       description="Nutrient limitation term in Nanophyto"    unit="-"          axis_ref="deptht" />
-       <field id="LDnut"       description="Nutrient limitation term in Diatoms"      unit="-"          axis_ref="deptht" />
-       <field id="LNFe"        description="Iron limitation term in Nanophyto"        unit="-"          axis_ref="deptht" />
-       <field id="LDFe"        description="Iron limitation term in Diatoms"          unit="-"          axis_ref="deptht" />
-       <field id="LNlight"     description="Light limitation term in Nanophyto"       unit="-"          axis_ref="deptht" />
-       <field id="LDlight"     description="Light limitation term in Diatoms"         unit="-"          axis_ref="deptht" />
-       <field id="Fe2"        description="Iron II concentration"                      unit="nmol/L"   axis_ref="deptht" />
-       <field id="Fe3"        description="Iron III concentration"                      unit="nmol/L"   axis_ref="deptht" />
-       <field id="FeL1"        description="Complexed Iron concentration with L1"       unit="nmol/L"   axis_ref="deptht" />
-       <field id="FeL2"        description="Complexed Iron concentration with L2"       unit="nmol/L"   axis_ref="deptht" />
-       <field id="FeP"        description="Precipitated Iron III"                      unit="nmol/L"   axis_ref="deptht" />
-       <field id="TL1"        description="Total L1 concentration"                      unit="nmol/L"   axis_ref="deptht" />
-       <field id="TL2"        description="Total L2 concentration"                      unit="nmol/L"   axis_ref="deptht" />
-       <field id="pdust"        description="dust concentration"                      unit="g/L"    />
-       <field id="Totlig"        description="Total ligand concentation"                unit="nmol/L"   axis_ref="deptht" />
-       <field id="Biron"        description="Bioavailable iron"                       unit="nmol/L"   axis_ref="deptht" />
-       <field id="Sdenit"        description="Nitrate reduction in the sediments"     unit="molN/m2/s"      />
-       <field id="Ironice"     description="Iron input/uptake due to sea ice"             unit="molFe/m2/s"      />
-       <field id="HYDR"       description="Iron input from hydrothemal vents"          unit="molFe/m2/s"      />
-       <field id="EPC100"      description="Export of carbon particles at 100 m"      unit="mol/m2/s"                     />
-       <field id="EPFE100"     description="Export of biogenic iron at 100 m"         unit="mol/m2/s"                     />
-       <field id="EPSI100"     description="Export of Silicate at 100 m"              unit="mol/m2/s"                     />
-       <field id="EPCAL100"    description="Export of Calcite at 100 m"               unit="mol/m2/s"                     />
-       <field id="Cflx"        description="DIC flux"                                 unit="mol/m2/s"                     />
-       <field id="Oflx"        description="Oxygen flux"                              unit="mol/m2/s"                     />
-       <field id="Kg"          description="Gas transfer"                             unit="mol/m2/s/uatm"                />
-       <field id="Dpco2"       description="Delta CO2"                                unit="uatm"                         />
-       <field id="Dpo2"        description="Delta O2"                                 unit="uatm"                         />
-       <field id="Heup"        description="Euphotic layer depth"                     unit="m"                            />
-       <field id="Irondep"     description="Iron deposition from dust"                 unit="mol/m2/s"                     />
-       <field id="Ironsed"     description="Iron deposition from sediment"             unit="mol/m2/s"  axis_ref="deptht"  />
+       <field id="PH"          description="PH"                                      unit="-"          axis_ref="deptht" />
+       <field id="CO3"         description="Bicarbonates"                            unit="mol/m3"     axis_ref="deptht" />
+       <field id="CO3sat"      description="CO3 saturation"                          unit="mol/m3"     axis_ref="deptht" />
+       <field id="PAR"         description="Photosynthetically Available Radiation"  unit="W/m2"       axis_ref="deptht" />
+       <field id="PPPHY"       description="Primary production of nanophyto"         unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="PPPHY2"      description="Primary production of diatoms"           unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="PPNEWN"      description="New Primary production of nanophyto"     unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="PPNEWD"      description="New Primary production of diatoms"       unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="PBSi"        description="Primary production of Si diatoms"        unit="molSi/m3/s" axis_ref="deptht" />
+       <field id="PFeN"        description="Primary production of nano iron"         unit="molFe/m3/s" axis_ref="deptht" />
+       <field id="PFeD"        description="Primary production of diatoms iron"      unit="molFe/m3/s" axis_ref="deptht" />
+       <field id="xfracal"     description="Calcifying fraction"                     unit="-"          axis_ref="deptht" />
+       <field id="PCAL"        description="Calcite production"                      unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="DCAL"        description="Calcite dissolution"                     unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="GRAZ1"       description="Grazing by microzooplankton"             unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="GRAZ2"       description="Grazing by mesozooplankton"              unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="REMIN"       description="Oxic remineralization of OM"             unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="DENIT"       description="Anoxic remineralization of OM"           unit="molC/m3/s"  axis_ref="deptht" />
+       <field id="Nfix"        description="Nitrogen fixation"                       unit="molN/m3/s"  axis_ref="deptht" />
+       <field id="Mumax"       description="Maximum growth rate"                     unit="s-1"        axis_ref="deptht" />
+       <field id="MuN"         description="Realized growth rate for nanophyto"      unit="s-1"        axis_ref="deptht" />
+       <field id="MuD"         description="Realized growth rate for diatomes"       unit="s-1"        axis_ref="deptht" />
+       <field id="LNnut"       description="Nutrient limitation term in Nanophyto"   unit="-"          axis_ref="deptht" />
+       <field id="LDnut"       description="Nutrient limitation term in Diatoms"     unit="-"          axis_ref="deptht" />
+       <field id="LNFe"        description="Iron limitation term in Nanophyto"       unit="-"          axis_ref="deptht" />
+       <field id="LDFe"        description="Iron limitation term in Diatoms"         unit="-"          axis_ref="deptht" />
+       <field id="LNlight"     description="Light limitation term in Nanophyto"      unit="-"          axis_ref="deptht" />
+       <field id="LDlight"     description="Light limitation term in Diatoms"        unit="-"          axis_ref="deptht" />
+       <field id="Fe2"         description="Iron II concentration"                   unit="nmol/L"     axis_ref="deptht" />
+       <field id="Fe3"         description="Iron III concentration"                  unit="nmol/L"     axis_ref="deptht" />
+       <field id="FeL1"        description="Complexed Iron concentration with L1"    unit="nmol/L"     axis_ref="deptht" />
+       <field id="FeL2"        description="Complexed Iron concentration with L2"    unit="nmol/L"     axis_ref="deptht" />
+       <field id="FeP"         description="Precipitated Iron III"                   unit="nmol/L"     axis_ref="deptht" />
+       <field id="TL1"         description="Total L1 concentration"                  unit="nmol/L"     axis_ref="deptht" />
+       <field id="TL2"         description="Total L2 concentration"                  unit="nmol/L"     axis_ref="deptht" />
+       <field id="pdust"       description="dust concentration"                      unit="g/L"                          />
+       <field id="Totlig"      description="Total ligand concentation"               unit="nmol/L"     axis_ref="deptht" />
+       <field id="Biron"       description="Bioavailable iron"                       unit="nmol/L"     axis_ref="deptht" />
+       <field id="Sdenit"      description="Nitrate reduction in the sediments"      unit="molN/m2/s"                    />
+       <field id="Ironice"     description="Iron input/uptake due to sea ice"        unit="molFe/m2/s"                   />
+       <field id="HYDR"        description="Iron input from hydrothemal vents"       unit="molFe/m2/s"                   />
+       <field id="EPC100"      description="Export of carbon particles at 100 m"     unit="mol/m2/s"                     />
+       <field id="EPFE100"     description="Export of biogenic iron at 100 m"        unit="mol/m2/s"                     />
+       <field id="EPSI100"     description="Export of Silicate at 100 m"             unit="mol/m2/s"                     />
+       <field id="EPCAL100"    description="Export of Calcite at 100 m"              unit="mol/m2/s"                     />
+       <field id="Cflx"        description="DIC flux"                                unit="mol/m2/s"                     />
+       <field id="Oflx"        description="Oxygen flux"                             unit="mol/m2/s"                     />
+       <field id="Kg"          description="Gas transfer"                            unit="mol/m2/s/uatm"                />
+       <field id="Dpco2"       description="Delta CO2"                               unit="uatm"                         />
+       <field id="Dpo2"        description="Delta O2"                                unit="uatm"                         />
+       <field id="Heup"        description="Euphotic layer depth"                    unit="m"                            />
+       <field id="Irondep"     description="Iron deposition from dust"               unit="mol/m2/s"                     />
+       <field id="Ironsed"     description="Iron deposition from sediment"           unit="mol/m2/s"  axis_ref="deptht"  />
      </group>         
 