Index: /vendors/XIOS/current/arch/arch-XT6_LYNX.env
===================================================================
--- /vendors/XIOS/current/arch/arch-XT6_LYNX.env	(revision 3472)
+++ /vendors/XIOS/current/arch/arch-XT6_LYNX.env	(revision 3472)
@@ -0,0 +1,9 @@
+#module unload netcdf
+#module unload hdf5
+export HDF5_INC_DIR=$WORKDIR/hdf5/include
+export HDF5_LIB_DIR=${CRAY_HDF5_DIR}/hdf5-parallel-cce/lib
+export NETCDF_INC_DIR=${CRAY_NETCDF_DIR}/netcdf-hdf5parallel-cce/include
+export NETCDF_LIB_DIR=${CRAY_NETCDF_DIR}/netcdf-hdf5parallel-cce/lib
+
+#module unload phdf5
+#module load phdf5/1.8.6
Index: /vendors/XIOS/current/arch/arch-XT6_LYNX.fcm
===================================================================
--- /vendors/XIOS/current/arch/arch-XT6_LYNX.fcm	(revision 3472)
+++ /vendors/XIOS/current/arch/arch-XT6_LYNX.fcm	(revision 3472)
@@ -0,0 +1,20 @@
+################################################################################
+###################        Projet xios - xmlioserver       #####################
+################################################################################
+
+%CCOMPILER      CC
+%FCOMPILER      ftn
+%LINKER         CC
+
+%BASE_CFLAGS    -DXIOS_LIBRARY  -DMPICH_SKIP_MPICXX -DNONE -DXIOS_LIBRARY -h msglevel_4
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -D XIOS_DEBUG -g 
+%DEBUG_CFLAGS   -D XIOS_DEBUG -g 
+
+%BASE_FFLAGS    -em -DXIOS_LIBRARY -DXIOS_LIBRARY -m 4
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -DXIOS_DEBUG -g 
+%DEBUG_FFLAGS   -DXIOS_DEBUG -g 
+
+%BASE_INC       -D __NONE__
+%BASE_LD        
Index: /vendors/XIOS/current/arch/arch-XT6_LYNX.path
===================================================================
--- /vendors/XIOS/current/arch/arch-XT6_LYNX.path	(revision 3472)
+++ /vendors/XIOS/current/arch/arch-XT6_LYNX.path	(revision 3472)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+#HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: /vendors/XIOS/current/bld.cfg
===================================================================
--- /vendors/XIOS/current/bld.cfg	(revision 3471)
+++ /vendors/XIOS/current/bld.cfg	(revision 3472)
@@ -35,5 +35,5 @@
 bld::tool::cc        %CCOMPILER
 bld::tool::fc        %FCOMPILER
-bld::tool::fpp       cpp
+bld::tool::fpp       cpp -P
 bld::tool::cpp       cpp
 bld::tool::cppflags  %BASE_INC -I${PWD}/extern/boost/include -I${PWD}/extern/rapidxml/include 
Index: /vendors/XIOS/current/extern/boost/include/boost/config/compiler/cray.hpp
===================================================================
--- /vendors/XIOS/current/extern/boost/include/boost/config/compiler/cray.hpp	(revision 3472)
+++ /vendors/XIOS/current/extern/boost/include/boost/config/compiler/cray.hpp	(revision 3472)
@@ -0,0 +1,64 @@
+//  (C) Copyright John Maddock 2011.
+//  Use, modification and distribution are subject to the
+//  Boost Software License, Version 1.0. (See accompanying file
+//  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
+
+//  See http://www.boost.org for most recent version.
+
+//  Greenhills C compiler setup:
+
+#define BOOST_COMPILER "Cray C version " BOOST_STRINGIZE(_RELEASE)
+
+#if _RELEASE < 7
+#  error "Boost is not configured for Cray compilers prior to version 7, please try the configure script."
+#endif
+
+//
+// Check this is a recent EDG based compiler, otherwise we don't support it here:
+//
+#ifndef __EDG_VERSION__
+#  error "Unsupported Cray compiler, please try running the configure script."
+#endif
+
+#include "boost/config/compiler/common_edg.hpp"
+
+//
+// Cray peculiarities, probably version 7 specific:
+//
+#undef BOOST_NO_AUTO_DECLARATIONS
+#undef BOOST_NO_AUTO_MULTIDECLARATIONS
+#define BOOST_HAS_NRVO
+#define BOOST_NO_VARIADIC_TEMPLATES
+#define BOOST_NO_UNIFIED_INITIALIZATION_SYNTAX
+#define BOOST_NO_UNICODE_LITERALS
+#define BOOST_NO_TWO_PHASE_NAME_LOOKUP
+#define BOOST_HAS_NRVO
+#define BOOST_NO_TEMPLATE_ALIASES
+#define BOOST_NO_STATIC_ASSERT
+#define BOOST_NO_SFINAE_EXPR
+#define BOOST_NO_SCOPED_ENUMS
+#define BOOST_NO_RVALUE_REFERENCES
+#define BOOST_NO_RANGE_BASED_FOR
+#define BOOST_NO_RAW_LITERALS
+#define BOOST_NO_NULLPTR
+#define BOOST_NO_NOEXCEPT
+#define BOOST_NO_LAMBDAS
+#define BOOST_NO_LOCAL_CLASS_TEMPLATE_PARAMETERS
+#define BOOST_NO_FUNCTION_TEMPLATE_DEFAULT_ARGS
+#define BOOST_NO_EXPLICIT_CONVERSION_OPERATORS
+#define BOOST_NO_DELETED_FUNCTIONS
+#define BOOST_NO_DEFAULTED_FUNCTIONS
+#define BOOST_NO_DECLTYPE_N3276
+#define BOOST_NO_DECLTYPE
+#define BOOST_NO_CONSTEXPR
+#define BOOST_NO_COMPLETE_VALUE_INITIALIZATION
+#define BOOST_NO_CHAR32_T
+#define BOOST_NO_CHAR16_T
+//#define BOOST_BCB_PARTIAL_SPECIALIZATION_BUG
+#define BOOST_MATH_DISABLE_STD_FPCLASSIFY
+//#define BOOST_HAS_FPCLASSIFY
+
+#define BOOST_SP_USE_PTHREADS 
+#define BOOST_AC_USE_PTHREADS 
+
+
Index: /vendors/XIOS/current/extern/boost/include/boost/config/select_compiler_config.hpp
===================================================================
--- /vendors/XIOS/current/extern/boost/include/boost/config/select_compiler_config.hpp	(revision 3471)
+++ /vendors/XIOS/current/extern/boost/include/boost/config/select_compiler_config.hpp	(revision 3472)
@@ -121,4 +121,7 @@
 //  example) also #define _MSC_VER
 #   define BOOST_COMPILER_CONFIG "boost/config/compiler/visualc.hpp"
+#elif defined _CRAYC
+// EDG based Cray compiler:
+#   define BOOST_COMPILER_CONFIG "boost/config/compiler/cray.hpp"
 
 #elif defined (BOOST_ASSERT_CONFIG)
Index: /vendors/XIOS/current/src/attribute_template.hpp
===================================================================
--- /vendors/XIOS/current/src/attribute_template.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/attribute_template.hpp	(revision 3472)
@@ -40,9 +40,9 @@
 
             /// Accesseur ///
-            inline ValueType getValue(void) const;
-            inline ValueType* getRef(void) ;
+            ValueType getValue(void) const;
+            ValueType* getRef(void) ;
 
             /// Mutateurs ///
-            inline void setValue(const ValueType & value);
+            void setValue(const ValueType & value);
 
             /// Destructeur ///
Index: /vendors/XIOS/current/src/generate_interface_impl.hpp
===================================================================
--- /vendors/XIOS/current/src/generate_interface_impl.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/generate_interface_impl.hpp	(revision 3472)
@@ -207,5 +207,5 @@
    }
     
-#define macro(T)\     
+#define macro(T)\
    template <>\
    void CInterface::AttributeFortran2003Interface<ARRAY(T,1)>(ostream& oss,const string& className,const string& name) \
@@ -309,5 +309,5 @@
    }
 
-#define macro(T)\   
+#define macro(T)\
    template <> \
    void CInterface::AttributeFortranInterfaceDeclaration<ARRAY(T,1)>(ostream& oss,const string& className,const string& name) \
Index: /vendors/XIOS/current/src/group_factory.hpp
===================================================================
--- /vendors/XIOS/current/src/group_factory.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/group_factory.hpp	(revision 3472)
@@ -23,9 +23,9 @@
 
          template <typename U>
-            static inline void AddGroup(boost::shared_ptr<U> pgroup,
+            static void AddGroup(boost::shared_ptr<U> pgroup,
                                         boost::shared_ptr<U> cgroup);
 
          template <typename U>
-            static inline void AddChild(boost::shared_ptr<U> group,
+            static void AddChild(boost::shared_ptr<U> group,
                                         boost::shared_ptr<typename U::RelChild> child);
 
@@ -34,34 +34,34 @@
 
          template <typename U>
-            static inline boost::shared_ptr<U>
+            static boost::shared_ptr<U>
                GetGroup(boost::shared_ptr<U> group, const StdString & id);
 
          template <typename U>
-            static inline boost::shared_ptr<typename U::RelChild>
+            static boost::shared_ptr<typename U::RelChild>
                GetChild(boost::shared_ptr<U> group, const StdString & id);
 
          template <typename U>
-            static inline int GetGroupNum(boost::shared_ptr<U> group);
+            static int GetGroupNum(boost::shared_ptr<U> group);
          template <typename U>
-            static inline int GetGroupIdNum(boost::shared_ptr<U> group);
+            static int GetGroupIdNum(boost::shared_ptr<U> group);
          template <typename U>
-            static inline int GetChildNum(boost::shared_ptr<U> group);
+            static int GetChildNum(boost::shared_ptr<U> group);
          template <typename U>
-            static inline int GetChildIdNum(boost::shared_ptr<U> group);
+            static int GetChildIdNum(boost::shared_ptr<U> group);
 
          /// Tests ///
          template <typename U>
-            static inline bool HasGroup(boost::shared_ptr<U> group, const StdString & id);
+            static bool HasGroup(boost::shared_ptr<U> group, const StdString & id);
 
          template <typename U>
-            static inline bool HasChild(boost::shared_ptr<U> group, const StdString & id);
+            static bool HasChild(boost::shared_ptr<U> group, const StdString & id);
 
          /// Instanciateur ///
          template <typename U>
-            static inline boost::shared_ptr<U>
+            static boost::shared_ptr<U>
                CreateGroup(boost::shared_ptr<U> group, const StdString & id = StdString(""));
 
          template <typename U>
-            static inline boost::shared_ptr<typename U::RelChild>
+            static boost::shared_ptr<typename U::RelChild>
                CreateChild(boost::shared_ptr<U> group, const StdString & id = StdString(""));
 
Index: /vendors/XIOS/current/src/group_template.hpp
===================================================================
--- /vendors/XIOS/current/src/group_template.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/group_template.hpp	(revision 3472)
@@ -55,6 +55,6 @@
 
          /// Accesseurs statiques ///
-         static inline StdString GetName(void);
-         static inline StdString GetDefName(void);
+         static StdString GetName(void);
+         static StdString GetDefName(void);
 
          /// Traitements ///
Index: /vendors/XIOS/current/src/node/context.cpp
===================================================================
--- /vendors/XIOS/current/src/node/context.cpp	(revision 3471)
+++ /vendors/XIOS/current/src/node/context.cpp	(revision 3472)
@@ -248,5 +248,5 @@
    {
 #define DECLARE_NODE(Name_, name_)    \
-   if (C##Name_##Definition::has(C##Name_##Definition::GetDefName())) \ 
+   if (C##Name_##Definition::has(C##Name_##Definition::GetDefName())) \
      C##Name_##Definition::get(C##Name_##Definition::GetDefName())->solveDescInheritance();
 #define DECLARE_NODE_PAR(Name_, name_)
Index: /vendors/XIOS/current/src/output/onetcdf4.cpp
===================================================================
--- /vendors/XIOS/current/src/output/onetcdf4.cpp	(revision 3471)
+++ /vendors/XIOS/current/src/output/onetcdf4.cpp	(revision 3472)
@@ -360,4 +360,10 @@
                                     const std::vector<StdSize> & scount, double * data)
       {
+         cout<<"writeData_"<<endl ;
+         for(int i=0;i<sstart.size();i++) cout<<sstart[i]<<"   " ;
+         cout<<endl ;
+         for(int i=0;i<scount.size();i++) cout<<scount[i]<<"   " ;
+         cout<<endl ;
+         
          CheckError(nc_put_vara_double(grpid, varid, &(sstart[0]), &(scount[0]), data));
 //         sync() ;
Index: /vendors/XIOS/current/src/output/onetcdf4.hpp
===================================================================
--- /vendors/XIOS/current/src/output/onetcdf4.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/output/onetcdf4.hpp	(revision 3472)
@@ -11,7 +11,9 @@
 #define MPI_INCLUDED
 #include <netcdf.h>
+#ifdef NETCDF_PAR_HEADER
 extern "C" {
 #include <netcdf_par.h>
 }
+#endif
 
 
Index: /vendors/XIOS/current/src/output/onetcdf4_impl.hpp
===================================================================
--- /vendors/XIOS/current/src/output/onetcdf4_impl.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/output/onetcdf4_impl.hpp	(revision 3472)
@@ -45,5 +45,5 @@
     if (value != NULL)
     {
-      CheckError(nc_def_var_fill(grpid, varid, 0, value));
+      CheckError(nc_def_var_fill(grpid, varid, 0, (void*)value));
       this->addAttribute(StdString("missing_value"), *value, &varname);
     }
Index: /vendors/XIOS/current/src/type/type_specialisation.hpp
===================================================================
--- /vendors/XIOS/current/src/type/type_specialisation.hpp	(revision 3471)
+++ /vendors/XIOS/current/src/type/type_specialisation.hpp	(revision 3472)
@@ -96,5 +96,5 @@
 */
 
-#define CTYPE_ARRAY(ValueType,NumsDims)                                \  
+#define CTYPE_ARRAY(ValueType,NumsDims)                                \
   template<>                                                           \
   size_t CType< ARRAY(ValueType,NumsDims)>::size() const                           \