Index: /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/CO2.nml
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/CO2.nml	(revision 3477)
+++ /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/CO2.nml	(revision 3478)
@@ -35,6 +35,19 @@
 &CO2_parameters
 
-! Initial Partial pressure in the air
-   pco2air = 365.0D0
+! Initial Partial pressure in the air [1960: 315; 1990: 353]
+   AtmCO20 = 370.0E0,
+! Compute the partial pressure of Atmospheric CO2
+   calcAtmpCO2 = .FALSE.
+   pCO2Method = 1  ! 1=MixRatio*slp, 2=Magnus formula
+!-----------------------------------------------------------------------------------!
+! Read external data for atmospheric CO2 values
+          ! Read  !   File   ! NetCDF  !  Var    !  RefTime   ! Input      !   Time   !
+          ! Input !   name   ! Logical !  name   !  yyyymmdd  ! Frequency  !  interp  !
+ATMCO2_N =    0  , 'CMIP5_GHG_1765_2005.nc' , .TRUE.  , 'CO2'   , '1764-07-01 00:00' ,  'yearly'  ,  .TRUE.
+! Read external data for atmospheric SLP
+AtmSLP_N  =    0  , 'AtmSLP.nc' , .TRUE.  ,'AtmSLP' , '1764-07-01 00:00'  , 'dummy' ,  .TRUE.
+AtmTDP_N  =    0  , 'AtmTDP.nc' , .TRUE.  ,'AtmTDP' , '1764-07-01 00:00'  , 'dummy' ,  .TRUE.
+!-----------------------------------------------------------------------------------!
+
 ! Initial pH value
    phstart = 8.0D0
@@ -57,5 +70,15 @@
 ! MethodCalcCO2=3 Follows et al., Ocean Modelling 2006
       MethodCalcCO2 = 2
-
+!
+! Calcium ion concentration
+!     [from : "Seawater : Its composition, properties and behaviour"
+!      (2nd Edition), Open University Course Team, 1995]
+!     seawater concentration    = 412 mg / l
+!     atomic weight             = 40.078 g / mol
+!     therefore, concentration  = 10.279 mmol / l
+!                               = 10.279 mol / m3
+        Caconc0 = 10.279E0
+! Normalize Calcium ion concentration by sea water salinity
+        Canorm  = .TRUE.
 /
 
Index: /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/Param.nml
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/Param.nml	(revision 3477)
+++ /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/Param.nml	(revision 3478)
@@ -55,4 +55,5 @@
 AssignAirPelFluxesInBFMFlag = .TRUE.
                       p_PAR = 0.40
+                       slp0 = 1013.25E0
                ChlLightFlag = 2
            LightForcingFlag = 1
Index: /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/bfm.nml
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/bfm.nml	(revision 3477)
+++ /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/bfm.nml	(revision 3478)
@@ -51,8 +51,10 @@
     bfm_init = 0
    bio_setup = 1
+  bfm_rstctl = .FALSE.
    out_fname = 'BFM_NEMO'
      out_dir = '.'
    out_title = 'BFM'
    out_delta = 12 
+   parallel_log = .TRUE.
 /
 
@@ -106,8 +108,4 @@
 &bfm_init_nml
    N1p0 = 1.0,
-   InitVar(3)%init = 0,
-   InitVar(3)%sbc  = .false.,
-   InitVar(3)%cbc  = .false.,
-   InitVar(3)%obc  = .false.,
    N3n0 = 5.0,
    N4n0 = 1.0,
@@ -129,4 +127,6 @@
    R6c0 = 1.0,
    R7c0 = 1.0,
+   O3c0 = 27060.00, ![mgC /m3]  2200 umol/Kg
+   O3h0 = 2660.0,   ![mmol eq/m3]  2600 umol/Kg
 /
 
@@ -139,5 +139,5 @@
 !-------------------------------------------------------------------------!
 &bfm_save_nml
-   ave_save = 'ETW','O2o',
+   ave_save = 'ETW','O2o','O3c','O3h',
           'EIR',
           'N1p',
@@ -180,5 +180,5 @@
           'qpPc(iiP3)',
           'qpPc(iiP4)',
-	'sunPI(iiP1)','sunPI(iiP2)','sunPI(iiP3)','sunPI(iiP4)'
+	'sunPI(iiP1)','sunPI(iiP2)','sunPI(iiP3)','sunPI(iiP4)',
 /
 
Index: /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_top
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_top	(revision 3477)
+++ /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_top	(revision 3478)
@@ -12,5 +12,5 @@
    nn_dttrc      =  1        !  time step frequency for passive sn_tracers      
    nn_writetrc   =  360     !  time step frequency for sn_tracer outputs
-   ln_top_euler  = .false.   !  use Euler timestepping at first step (T) or not (F)
+   ln_top_euler  = .true.   !  use Euler timestepping at first step (T) or not (F)
    ln_rsttr      = .false.   !  start from a restart file (T) or not (F)
    nn_rsttr      =   0       !  restart control = 0 initial time step is not compared to the restart file value
@@ -19,4 +19,5 @@
    cn_trcrst_in  = "restart_trc"   !  suffix of pass. sn_tracer restart name (input)
    cn_trcrst_out = "restart_trc"   !  suffix of pass. sn_tracer restart name (output)
+   ln_trcdta     =  .false.        !  Initialisation from data input file (T) or not (F)
 !
 !              !    name   !           title of the field              !   units    ! initial data ! save   !
Index: /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/runscript
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/runscript	(revision 3477)
+++ /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/runscript	(revision 3478)
@@ -1,13 +1,15 @@
-#! /bin/sh -x
+#! /bin/sh 
 
 #BSUB -a poe
-#BSUB -J GYRE_BFM          # Name of the job.
+#BSUB -J GYRE_BFM         # Name of the job.
 #BSUB -o GYRE_BFM_%J.out  # Appends std output to file %J.out.
 #BSUB -e GYRE_BFM_%J.err  # Appends std error to file %J.out.
 #BSUB -P nemo
 #BSUB -q poe_short    # queue
-#BSUB -n 4             # Number of CPUs
-#BSUB -x 
+#BSUB -n 4            # Number of CPUs
+##BSUB -x 
 ###BSUB -R "span[ptile=32]"
+
+set -evx
 
 export MP_WAIT_MODE=poll
@@ -19,10 +21,23 @@
 export MP_TASK_AFFINITY=core
 
-workdir="/data/ans017/EXPERIMENTS/GYRE_BFM"
+EXP="EXP00"
+
+workdir="/data/ans033/EXPERIMENTS/GYRE_BFM/${EXP}"
 execdir=`pwd`
 
-cd $workdir
+if [ ! -d ${workdir} ] ; then
+  mkdir -p ${workdir}
+fi
+
+cd ${workdir}
 rm -rf *
+# Copy files to exp folder
+cp ${execdir}/opa ./opa.x
 cp ${execdir}/* ./
 
-time mpirun.lsf opa
+# Launch the model
+
+time mpirun.lsf opa.x 
+
+echo " ${EXP} DONEEE!!!"
+