Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 3488)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 3489)
@@ -124,5 +124,5 @@
 
 	<field id="empmr"        description="Net Upward Water Flux"                                        unit="kg/m2/s"  />
-	<field id="empsmr"       description="concentration/dilution water flux"                            unit="kg/m2/s"  />
+	<field id="saltflx"      description="Downward Salt Flux"                                           unit="PSU/m2/s" />
 	<field id="snowpre"      description="Snow precipitation"                                           unit="kg/m2/s"  />
 	<field id="runoffs"      description="River Runoffs"                                                unit="Kg/m2/s"  />
@@ -145,4 +145,5 @@
 	<field id="qsb_oce"      description="Sensible Downward Heat Flux over open ocean"                  unit="W/m2"     />
 	<field id="qla_oce"      description="Latent Downward Heat Flux over open ocean"                    unit="W/m2"     />
+	<field id="qhc_oce"      description="Downward Heat Content of E-P over open ocean"                 unit="W/m2"     />
 	<field id="taum_oce"     description="wind stress module over open ocean"                           unit="N/m2"     />
 
@@ -173,4 +174,7 @@
 	<field id="v_imasstr"    description="Sea-ice mass transport along j-axis"                          unit="kg/s"     />
 
+	<!-- available if not defined key_vvl -->
+	<field id="emp_x_sst"      description="Concentration/Dilution term on SST"                         unit="kgC/m2/s" />
+	<field id="emp_x_sss"      description="Concentration/Dilution term on SSS"                       unit="kgPSU/m2/s" />
 	<!-- available key_coupled -->
 	<field id="snow_ao_cea"  description="Snow over ice-free ocean (cell average)"                      unit="kg/m2/s"  />
@@ -1016,5 +1020,5 @@
 	  <field ref="empmr"        name="sowaflup"  />
 	  <field ref="qsr"          name="soshfldo"  />
-	  <field ref="empsmr"       name="sowaflcd"  />
+	  <field ref="saltflx"      name="sosfldow"  />
 	  <field ref="qt"           name="sohefldo"  />
 	  <field ref="mldr10_1"     name="somxl010"  />
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 3488)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 3489)
@@ -192,8 +192,10 @@
 
             fsbbq(ji,jj) = ( 1.0 - ( ifvt + iflt ) ) * fscmbq(ji,jj)     ! store residual heat flux (to put into the ocean at the next time-step)
-            zqhc = ( rdq_snw(ji,jj) + rdq_ice(ji,jj) ) * r1_rdtice       ! heat flux due to snow & ice heat content exchange
-            !
+            zqhc = ( rdq_snw(ji,jj)                                     &
+                 & + rdq_ice(ji,jj) * ( 1.- zswitch) ) * r1_rdtice       ! heat flux due to snow ( & ice heat content, 
+            !                                                            !           if ice/ocean mass exchange active) 
             qsr  (ji,jj) = zqsr                                          ! solar heat flux 
-            qns  (ji,jj) = zqns - fdtcn(ji,jj) + zqhc                    ! non solar heat flux
+            qns  (ji,jj) = zqns - fdtcn(ji,jj) + zqhc                    ! non solar heat flux 
+            !
             !                          !------------------------------------------!
             !                          !      mass flux at the ocean surface      !
@@ -223,5 +225,5 @@
             ! salt and mass fluxes : non concentration dilution term in salt flux  and add F-M term in volume flux
             sfx (ji,jj) = zfsalt +                  zswitch  * zcd   ! salt flux (+ C/D if no ice/ocean mass exchange)
-            emp (ji,jj) = zemp   + zemp_snw + ( 1.- zswitch) * zfmm  ! mass flux (- F/M mass flux if no ice/ocean mass exchange)
+            emp (ji,jj) = zemp   + zemp_snw + ( 1.- zswitch) * zfmm  ! mass flux (+ F/M mass flux if ice/ocean mass exchange)
             !
          END DO
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 3488)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 3489)
@@ -372,22 +372,16 @@
          CALL histdef( nid_T, "sossheig", "Sea Surface Height"                 , "m"      ,   &  ! ssh
             &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
->>>>>>>>>>>
-      CALL histwrite( nid_T, "sowaflup", it, ( emp-rnf )   , ndim_hT, ndex_hT )   ! upward water flux
-      CALL histwrite( nid_T, "sosfldow", it, sfx           , ndim_hT, ndex_hT )   ! downward salt flux 
-                                                                                  ! (includes virtual salt flux beneath ice 
-                                                                                  ! in linear free surface case)
+         CALL histdef( nid_T, "sowaflup", "Net Upward Water Flux"              , "Kg/m2/s",   &  ! (emp-rnf)
+            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+         CALL histdef( nid_T, "sosfldow", "downward salt flux"                 , "PSU/m2/s",  &  ! sfx
+            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
 #if ! defined key_vvl
-      zw2d(:,:) = emp (:,:) * tsn(:,:,1,jp_tem) * tmask(:,:,1)
-      CALL histwrite( nid_T, "sosst_cd", it, zw2d, ndim_hT, ndex_hT )             ! c/d term on sst
-      zw2d(:,:) = emp (:,:) * tsn(:,:,1,jp_sal) * tmask(:,:,1)
-      CALL histwrite( nid_T, "sosss_cd", it, zw2d, ndim_hT, ndex_hT )             ! c/d term on sss
-#endif
-<<<<<<<<<<
-         CALL histdef( nid_T, "sowaflup", "Net Upward Water Flux"              , "Kg/m2/s",   &  ! (emp-rnf)
-            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-         CALL histdef( nid_T, "sofldow", "downward salt flux"                  , "PSU/m2/s",  &  ! sfx
-            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-         CALL histdef( nid_T, "sosalflx", "Surface Salt Flux"                  , "Kg/m2/s",   &  ! (emps-rnf) * sn
-            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+         CALL histdef( nid_T, "sosst_cd", "Concentration/Dilution term on temperature"        &  ! emp * tsn(:,:,1,jp_tem)
+            &                                                                  , "KgC/m2/s",  &  ! sosst_cd
+            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+         CALL histdef( nid_T, "sosss_cd", "Concentration/Dilution term on salinity"           &  ! emp * tsn(:,:,1,jp_sal)
+            &                                                                  , "KgPSU/m2/s",&  ! sosss_cd
+            &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+#endif
          CALL histdef( nid_T, "sohefldo", "Net Downward Heat Flux"             , "W/m2"   ,   &  ! qns + qsr
             &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/DIA/diawri_dimg.h90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/DIA/diawri_dimg.h90	(revision 3488)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/DIA/diawri_dimg.h90	(revision 3489)
@@ -54,5 +54,6 @@
     !!  level 14: qct(:,:)                 equivalent flux due to treshold SST
     !!  level 15: fbt(:,:)                 feedback term .
-    !!  level 16: ( sfx (:,:) - rnf(:,:) ) concentration/dilution water flux
+    !!  level 16: ( emp * sss )            concentration/dilution term on salinity
+    !!  level 17: ( emp * sst )            concentration/dilution term on temperature
     !!  level 17: fsalt(:,:)               Ice=>ocean net freshwater
     !!  level 18: gps(:,:)                 the surface pressure (m).
@@ -62,5 +63,5 @@
     !! History:  OPA  ! 1997-02 ( Clipper Group ) dimg files
     !!            -   ! 2003-12 ( J.M. Molines) f90, mpp output for OPA9.0
-    !!   NEMO    1.0  ! 2005-05  (S. Theetten) add sfx  fsalt move gps spgu spgv 2 lines below
+    !!   NEMO    1.0  ! 2005-05  (S. Theetten) add emps fsalt move gps spgu spgv 2 lines below
     !!            -   ! 2005-11  (V. Garnier) Surface pressure gradient organization
     !!----------------------------------------------------------------------
@@ -107,5 +108,5 @@
 
 
-    inbsel = 17
+    inbsel = 18
 
     IF( inbsel >  jpk ) THEN
@@ -172,5 +173,6 @@
        !        fsel(:,:,14) = fsel(:,:,14) + qct(:,:)
        !        fsel(:,:,15) = fsel(:,:,15) + fbt(:,:)
-       fsel(:,:,16) = fsel(:,:,16) + ( sfx (:,:)-rnf(:,:) ) 
+       fsel(:,:,16) = fsel(:,:,16) + ( emp(:,:)*tsn(:,:,1,jp_sal) ) 
+       fsel(:,:,17) = fsel(:,:,17) + ( emp(:,:)*tsn(:,:,1,jp_tem) ) 
        !
        ! Output of dynamics and tracer fields and selected fields
@@ -240,5 +242,6 @@
           !         fsel(:,:,14) =  qct(:,:)
           !         fsel(:,:,15) =  fbt(:,:)
-          fsel(:,:,16) = ( sfx (:,:)-rnf(:,:) ) * tmask(:,:,1) 
+          fsel(:,:,16) = ( emp(:,:)-tsn(:,:,1,jp_sal) ) * tmask(:,:,1) 
+          fsel(:,:,17) = ( emp(:,:)-tsn(:,:,1,jp_tem) ) * tmask(:,:,1) 
           !
           !         qct(:,:) = 0._wp
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 3488)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 3489)
@@ -392,4 +392,5 @@
       CALL iom_put( "qsb_oce", - zqsb )                 ! output downward sensible heat over the ocean
       CALL iom_put( "qla_oce", - zqla )                 ! output downward latent   heat over the ocean
+      CALL iom_put( "qhc_oce",   qns-zqlw+zqsb+zqla )   ! output downward heat content of E-P over the ocean
       CALL iom_put( "qns_oce",   qns  )                 ! output downward non solar heat over the ocean
       !