Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_MERCATOR_CLUSTER
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_MERCATOR_CLUSTER	(revision 3491)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_MERCATOR_CLUSTER	(revision 3492)
@@ -4,8 +4,8 @@
 #PBS -e sette.$PBS_JOBID.err
 #PBS -o sette.$PBS_JOBID.out
-#PBS -l nodes=2:ppn=8
-#PBS -q multi
+#PBS -l nodes=NODES:ppn=NPROCSNODE
+#PBS -q QUEUE
 #PBS -l walltime=03:00:00
-#PBS -l mem=24gb
+#PBS -l mem=MEMgb
 
 #
@@ -22,5 +22,6 @@
 # Local settings for machine IBM Power6 (VARGAS at IDRIS France)
 #
-export MPIRUN="mpiexec -n $OCEANCORES"
+#cbr export MPIRUN="mpiexec -n $OCEANCORES"
+export MPIRUN="mpirun -np $OCEANCORES"
 
 #
@@ -50,5 +51,5 @@
 #
 cd ${EXE_DIR}
-
+ ln -sf /home/eremy/NEMO/dev_r3342_MERCATOR7_SST/ctl_MERCATOR7/sst_y2006m01.nc sst_y0001m01.nc
   echo Running on host `hostname`
   echo Time is `date`
@@ -61,4 +62,5 @@
   if [ MPI_FLAG == "yes" ]; then
      time ${MPIRUN} ./opa
+#cbr     mpirun -np $OCEANCORES ./opa
   else
      time ./opa
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 3491)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 3492)
@@ -1,1 +1,1 @@
-ORCA2_LIM_nemo_v3.3.tar
+ORCA2_LIM_nemo_v3.4.tar
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/prepare_job.sh
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/prepare_job.sh	(revision 3491)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/prepare_job.sh	(revision 3492)
@@ -198,5 +198,5 @@
 					# number of processes required is an integer multiple of 4
 					#
-					NB_NODES=$( echo $NB_PROC | awk '{print $1 / 4}')
+					NB_NODES=$( echo $NB_PROC | awk '{print $1  $1 / 4}')
 				else
 					#
@@ -207,4 +207,27 @@
 	       			fi
 				;;
+                        ifort_MERCATOR_CLUSTER)
+                                echo NB_PROCS ${NB_PROC}
+                                echo NB_NODES ${NB_NODES}
+                                echo  NB_PROC ${NB_PROC} 
+                                if [ ${NB_PROC} -eq 1 ] ; then
+                                   NB_NODES=1
+                                   QUEUE=monoproc
+                                   NB_PROC_NODE=${NB_PROC} 
+                                else
+                                   if [ ${NB_PROC} -le 8 ] ; then 
+                                      NB_NODES=1
+                                      QUEUE=mono
+                                      NB_PROC_NODE=${NB_PROC} 
+                                   else
+                                      NB_NODES=$( echo $NB_PROC | awk '{print $1 - $1 % 8}'  | awk '{print $1 / 8 }')
+                                      QUEUE=multi
+                                      NB_PROC_NODE=8
+                                  fi    
+                                fi    
+                                echo NB_PROCS     ${NB_PROC}
+                                echo NB_NODES     ${NB_NODES}
+                                echo NB_PROC_NODE ${NB_PROC_NODE} 
+				;;
 			*)
 				NB_NODES=${NB_PROC}
@@ -215,5 +238,9 @@
 # Pass settings into job file by using sed to edit predefined strings
 #
-        cat ${SETTE_DIR}/job_batch_template | sed -e"s/NODES/${NB_NODES}/" -e"s/NPROCS/${NB_PROC}/" \
+         ((mem=5*NB_PROC))
+         echo NB_NODES NB_PROC QUEUE ${NB_NODES} ${NB_PROC} ${QUEUE}
+        cat ${SETTE_DIR}/job_batch_template | sed -e"s/NODES/${NB_NODES}/" -e"s/NPROCSNODE/${NB_PROC_NODE}/" \
+             -e"s/NPROCS/${NB_PROC}/" \
+             -e"s/QUEUE/${QUEUE}/" -e"s/MEM/${mem}/" \
              -e"s:DEF_SETTE_DIR:${SETTE_DIR}:" -e"s:DEF_INPUT_DIR:${INPUT_DIR}:" \
              -e"s:DEF_EXE_DIR:${EXE_DIR}:" \
Index: /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/sette.sh
===================================================================
--- /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/sette.sh	(revision 3491)
+++ /branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/SETTE/sette.sh	(revision 3492)
@@ -129,6 +129,6 @@
 #-
 # Compiler among those in NEMOGCM/ARCH
-COMPILER=PW6_CALYPSO
-export BATCH_COMMAND_PAR="bsub < "
+COMPILER=ifort_MERCATOR_CLUSTER
+export BATCH_COMMAND_PAR="qsub "
 export BATCH_COMMAND_SEQ=$BATCH_COMMAND_PAR
 