Index: anches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/WindOxReaeration_3.nml
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/GYRE_BFM/EXP00/WindOxReaeration_3.nml	(revision 3513)
+++ 	(revision )
@@ -1,45 +1,0 @@
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-! MODEL  BFM - Biogeochemical Flux Model 
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-!BOP
-!
-! !ROUTINE: WindOxReaeration_3
-!
-! DESCRIPTION
-!   List of parameters values
-!   for mem_WindOxReaeration_3 filled by InitWindOxReaeration_3
-!
-! AUTHORS
-!   the BFM team
-!
-! COPYING
-!   
-!   Copyright (C) 2006 P. Ruardij, M. Vichi
-!   (rua@nioz.nl, vichi@bo.ingv.it)
-!
-!   This program is free software; you can redistribute it and/or modify
-!   it under the terms of the GNU General Public License as published by
-!   the Free Software Foundation;
-!   This program is distributed in the hope that it will be useful,
-!   but WITHOUT ANY WARRANTY; without even the implied warranty of
-!   MERCHANTEABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-!   GNU General Public License for more details.
-!
-!EOP
-!-------------------------------------------------------------------------!
-!BOC
-!
-!
-!  k:  	 k = 0.31 cm/h  * 1/100 m *  24h = 0.074 m/d
-
-&WindOxReaeration_3_parameters
-k = 0.074
-/
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-!END namelist
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-
-!BOP
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-! MODEL  BFM - Biogeochemical Flux Model 
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
Index: anches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/PELAGOS/EXP00/WindOxReaeration_3.nml
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/PELAGOS/EXP00/WindOxReaeration_3.nml	(revision 3513)
+++ 	(revision )
@@ -1,45 +1,0 @@
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-! MODEL  BFM - Biogeochemical Flux Model 
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-!BOP
-!
-! !ROUTINE: WindOxReaeration_3
-!
-! DESCRIPTION
-!   List of parameters values
-!   for mem_WindOxReaeration_3 filled by InitWindOxReaeration_3
-!
-! AUTHORS
-!   the BFM team
-!
-! COPYING
-!   
-!   Copyright (C) 2006 P. Ruardij, M. Vichi
-!   (rua@nioz.nl, vichi@bo.ingv.it)
-!
-!   This program is free software; you can redistribute it and/or modify
-!   it under the terms of the GNU General Public License as published by
-!   the Free Software Foundation;
-!   This program is distributed in the hope that it will be useful,
-!   but WITHOUT ANY WARRANTY; without even the implied warranty of
-!   MERCHANTEABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-!   GNU General Public License for more details.
-!
-!EOP
-!-------------------------------------------------------------------------!
-!BOC
-!
-!
-!  k:  	 k = 0.31 cm/h  * 1/100 m *  24h = 0.074 m/d
-
-&WindOxReaeration_3_parameters
-k = 0.074
-/
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-!END namelist
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-
-!BOP
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-! MODEL  BFM - Biogeochemical Flux Model 
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
Index: anches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/WindOxReaeration_3.nml
===================================================================
--- /branches/2012/dev_r3379_CMCC6_topbfm/NEMOGCM/CONFIG/PELAGOS_OFF/EXP00/WindOxReaeration_3.nml	(revision 3513)
+++ 	(revision )
@@ -1,45 +1,0 @@
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-! MODEL  BFM - Biogeochemical Flux Model 
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-!BOP
-!
-! !ROUTINE: WindOxReaeration_3
-!
-! DESCRIPTION
-!   List of parameters values
-!   for mem_WindOxReaeration_3 filled by InitWindOxReaeration_3
-!
-! AUTHORS
-!   the BFM team
-!
-! COPYING
-!   
-!   Copyright (C) 2006 P. Ruardij, M. Vichi
-!   (rua@nioz.nl, vichi@bo.ingv.it)
-!
-!   This program is free software; you can redistribute it and/or modify
-!   it under the terms of the GNU General Public License as published by
-!   the Free Software Foundation;
-!   This program is distributed in the hope that it will be useful,
-!   but WITHOUT ANY WARRANTY; without even the implied warranty of
-!   MERCHANTEABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-!   GNU General Public License for more details.
-!
-!EOP
-!-------------------------------------------------------------------------!
-!BOC
-!
-!
-!  k:  	 k = 0.31 cm/h  * 1/100 m *  24h = 0.074 m/d
-
-&WindOxReaeration_3_parameters
-k = 0.074
-/
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-!END namelist
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-
-!BOP
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
-! MODEL  BFM - Biogeochemical Flux Model 
-!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-